import setpath, config

from TAL.TALInterpreter import TALInterpreter
from Products.PageTemplates.Expressions import getEngine
from cStringIO import StringIO

class TERRYInterpreter(TALInterpreter):
    def __init__(self, *args, **kw):
        if kw.has_key('TERRYseqs'):
            self.TERRYseqs=kw['TERRYseqs']
            del kw['TERRYseqs']
        else:
            self.TERRYseqs=(config.TERRYstart, config.TERRYend, config.TERRYescape)
        TALInterpreter.__init__(self, *args, **kw)

    def do_beginScope(self):
        if not self.tal:
            self.stream.write(self.TERRYseqs[0])
        TALInterpreter.do_beginScope(self)

    def do_scopeCommand(self, *attrs):
        if not self.tal:
            self.stream.write('%s:%s="%s" ' % attrs)

    def do_endScope(self):
        if not self.tal:
            self.stream.write(self.TERRYseqs[1])
        TALInterpreter.do_endScope(self)
    
    def do_TERRYescape(self, what):
        if what not in self.TERRYseqs[:2]:
            # what is this? This is not an escape.
            self.stream.write(what)
        if self.tal:
            self.stream.write(what)
        else:
            self.stream.write(self.TERRYseqs[0])
            if what==self.TERRYseqs[0]:
                self.stream.write(self.TERRYseqs[2])
            else:            
                self.stream.write(self.TERRYseqs[1])
    
def interpret(program, macros, context, source=0):
    output = StringIO()
    #c.update(extra_context)

    TERRYInterpreter(program, macros, getEngine().getContext(context),
                   output, tal=not source, strictinsert=0)()
    return output.getvalue()
