import generate, syntax, config
from interpreter import TERRYInterpreter
from Products.PageTemplates.Expressions import getEngine
from cStringIO import StringIO
import string, sys, pprint
import TextTools

def process(text, source=0, context={},
             TERRYstart=config.TERRYstart, TERRYend=config.TERRYend,
             TERRYescape=config.TERRYescape):
    """Render some text
    """
    #Compile the TAL and METAL statments.
    table = syntax.table(TERRYstart, TERRYend, TERRYescape)
    table = TextTools.tag(text, table)[1]
    errors = ()
    gen = generate.generator(text, table)
    program, macros = gen.program, gen.macros
    #Render
    output = StringIO()
    c = context

    TERRYInterpreter(program, macros,
                   getEngine().getContext(c),
                   output,
                   tal=not source, strictinsert=0,
                   TERRYseqs=(TERRYstart, TERRYend, TERRYescape))()
    return output.getvalue()

def main(*args):
    if len(args) < 1:
        input = sys.stdin
    else:
        input = open(args[0], 'r')
    if len(args) < 2:
        output = sys.stdout
    else:
        output = open(args[1], 'w')
    # FIXME: perhaps it would be nice to add getopt processing here?
    output.write(process(input.read()))

if __name__ == '__main__':
    main(*sys.argv[1:])
